//=============================================================================
// Follow Player Test
//=============================================================================
class CopFollower extends CozCop;

#exec OBJ LOAD FILE="..\System\Cozmo_RPG_Pack.u"
#exec OBJ LOAD FILE="..\System\RPGMasterTest.u"

Var DeusExPlayer DXP;
var bool bRunningTo;
var int WaitingFor;
var PoliceCrimeMon PCM;

function BeginPlay()
{
	local PoliceCrimeMon PCMM;

	foreach AllActors(class'PoliceCrimeMon', PCMM)
	{
		PCM = PCMM;
	}

	SetTimer(1.0, true);

	Super.BeginPlay();
}

function Carcass SpawnCarcass()
{
	if(DXP != None)
	{
		DXP.ClientMessage("|p2A cop you were leading has been killed!");
	}

	return Super.SpawnCarcass();
}

function Tick(float deltaTime)
{
	if(DXP != None)
	{
		if(DXP.Health < 1)
		{
			DXP = None;
		}
	}

	Super.Tick(deltatime);
}

function Timer()
{
	local vector loc;

	if(WaitingFor > 0)
	{
		WaitingFor --;

		if(WaitingFor == 0)
		{
			Orders = 'Wandering';
			gotoState('Wandering');
		}
	}

	if((DXP != None) && (Enemy == None))
	{
		if(VSize(Location-DXP.Location) > 1200)
		{
			loc = DXP.Location;
			loc -= 32.0 * DXP.CollisionRadius * vector(DXP.ViewRotation);
			loc.Z += DXP.CollisionHeight * 0.9;

			SetLocation(loc);
		}
		else if(VSize(Location-DXP.Location) < 200)
		{
			gotoState('Standing');
		}
		else
		{
			GetMoving();
		}
	}
}

function Frob(Actor Frobber, Inventory frobWith) 
{
	local int i;

	if(DXP != DeusExPlayer(Frobber))
	{
		for(i=1; i<20; i++)
		{
			if(DeusExPlayer(Frobber) == PCM.PlayerCop[i])
			{
				if(DXP == None)
				{
					DeusExPlayer(Frobber).ClientMessage("|p3Cop: Lead the way officer.");
					DXP = DeusExPlayer(Frobber);
					GetMoving();
					return;
				}
				else
				{
					DeusExPlayer(Frobber).ClientMessage("|p3Cop: I'm currently taking orders from "$DXP.PlayerReplicationInfo.PlayerName$".");
				}
			}
		}
	}

	if(DXP == DeusExPlayer(Frobber)) //move!
	{
		DXP.ClientMessage("|p3Cop: All right. I'll stand guard here for a while."); //90 seconds for cops
		WaitingFor = 90;
		DXP = None;
		gotoState('Standing');
		Orders='Standing';
	}
}

function GetMoving()
{
	if(DXP != None)
	{
		if(VSize(Location-DXP.Location) > 300)
		{
			bRunningTo = True;
			gotoState('Follow');
		}
		else if(VSize(Location-DXP.Location) > 200)
		{
			bRunningTo = False;
			gotoState('Follow');
		}
		else
		{
			gotoState('Standing');
		}
	}
}

State Follow
{
	function SetFall()
	{
		StartFalling('Patrolling', 'ContinuePatrol');
	}

	function HitWall(vector HitNormal, actor Wall)
	{
		if (Physics == PHYS_Falling)
			return;
		Global.HitWall(HitNormal, Wall);
		CheckOpenDoor(HitNormal, Wall);
	}
	
	function AnimEnd()
	{
		PlayWaiting();
	}

	function BeginState()
	{
		//StandUp();
		//SetEnemy(None, EnemyLastSeen, true);
		Disable('AnimEnd');
		//SetupWeapon(false);
		//SetDistress(false);
		//bStasis = false;
		SeekPawn = None;
		//EnableCheckDestLoc(false);
	}

	function EndState()
	{
		//EnableCheckDestLoc(false);
		Enable('AnimEnd');
		//bStasis = true;
	}

	Begin:

	if(DXP != none)
	{
		if(bRunningTo == False)
		{
			PlayWalking();
			MoveToward(DXP, 0.120000);
		}
		else
		{
			PlayRunning();
			MoveToward(DXP, 180.000000);
		}

	}
}

defaultproperties
{
     bRespawning=true
}